Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 6639)
@@ -3151,70 +4144,71 @@
 		  !!
 		  !! extract fields at surface
-		  if (jk .eq. 1) then
-                     trc2d(ji,jj,172) = zchn              !! Pn chlorophyll
-                     trc2d(ji,jj,173) = zphn              !! Pn biomass
-                     trc2d(ji,jj,174) = fjln              !! Pn J-term
-                     trc2d(ji,jj,175) = (fprn * zphn)     !! Pn PP
-                     trc2d(ji,jj,176) = zchd              !! Pd chlorophyll
-                     trc2d(ji,jj,177) = zphd              !! Pd biomass
-                     trc2d(ji,jj,178) = fjld              !! Pd J-term
-                     trc2d(ji,jj,179) = xpar(ji,jj,jk)    !! Pd PP
-                     trc2d(ji,jj,180) = loc_T             !! local temperature
-                  endif
-		  !!
-		  !! extract fields at 50m (actually 44-50m)
-		  if (jk .eq. 18) then
-                     trc2d(ji,jj,181) = zchn              !! Pn chlorophyll
-                     trc2d(ji,jj,182) = zphn              !! Pn biomass
-                     trc2d(ji,jj,183) = fjln              !! Pn J-term
-                     trc2d(ji,jj,184) = (fprn * zphn)     !! Pn PP
-                     trc2d(ji,jj,185) = zchd              !! Pd chlorophyll
-                     trc2d(ji,jj,186) = zphd              !! Pd biomass
-                     trc2d(ji,jj,187) = fjld              !! Pd J-term
-                     trc2d(ji,jj,188) = xpar(ji,jj,jk)    !! Pd PP
-                     trc2d(ji,jj,189) = loc_T             !! local temperature
-                  endif
-		  !!
-		  !! extract fields at 100m
-		  if (jk .eq. i0100) then
-                     trc2d(ji,jj,190) = zchn              !! Pn chlorophyll
-                     trc2d(ji,jj,191) = zphn              !! Pn biomass
-                     trc2d(ji,jj,192) = fjln              !! Pn J-term
-                     trc2d(ji,jj,193) = (fprn * zphn)     !! Pn PP
-                     trc2d(ji,jj,194) = zchd              !! Pd chlorophyll
-                     trc2d(ji,jj,195) = zphd              !! Pd biomass
-                     trc2d(ji,jj,196) = fjld              !! Pd J-term
-                     trc2d(ji,jj,197) = xpar(ji,jj,jk)    !! Pd PP
-                     trc2d(ji,jj,198) = loc_T             !! local temperature
-                  endif
+		 !! if (jk .eq. 1) then
+                 !!    trc2d(ji,jj,172) = zchn              !! Pn chlorophyll
+                 !!    trc2d(ji,jj,173) = zphn              !! Pn biomass
+                 !!    trc2d(ji,jj,174) = fjln              !! Pn J-term
+                 !!    trc2d(ji,jj,175) = (fprn * zphn)     !! Pn PP
+                 !!    trc2d(ji,jj,176) = zchd              !! Pd chlorophyll
+                 !!    trc2d(ji,jj,177) = zphd              !! Pd biomass
+                 !!    trc2d(ji,jj,178) = fjld              !! Pd J-term
+                 !!    trc2d(ji,jj,179) = xpar(ji,jj,jk)    !! Pd PP
+                 !!    trc2d(ji,jj,180) = loc_T             !! local temperature
+                 !! endif
+		 !! !!
+		 !! !! extract fields at 50m (actually 44-50m)
+		 !! if (jk .eq. 18) then
+                 !!    trc2d(ji,jj,181) = zchn              !! Pn chlorophyll
+                 !!    trc2d(ji,jj,182) = zphn              !! Pn biomass
+                 !!    trc2d(ji,jj,183) = fjln              !! Pn J-term
+                 !!    trc2d(ji,jj,184) = (fprn * zphn)     !! Pn PP
+                 !!    trc2d(ji,jj,185) = zchd              !! Pd chlorophyll
+                 !!    trc2d(ji,jj,186) = zphd              !! Pd biomass
+                 !!    trc2d(ji,jj,187) = fjld              !! Pd J-term
+                 !!    trc2d(ji,jj,188) = xpar(ji,jj,jk)    !! Pd PP
+                 !!    trc2d(ji,jj,189) = loc_T             !! local temperature
+                 !! endif
+		 !! !!
+		 !! !! extract fields at 100m
+		 !! if (jk .eq. i0100) then
+                 !!    trc2d(ji,jj,190) = zchn              !! Pn chlorophyll
+                 !!    trc2d(ji,jj,191) = zphn              !! Pn biomass
+                 !!    trc2d(ji,jj,192) = fjln              !! Pn J-term
+                 !!    trc2d(ji,jj,193) = (fprn * zphn)     !! Pn PP
+                 !!    trc2d(ji,jj,194) = zchd              !! Pd chlorophyll
+                 !!    trc2d(ji,jj,195) = zphd              !! Pd biomass
+                 !!    trc2d(ji,jj,196) = fjld              !! Pd J-term
+                 !!    trc2d(ji,jj,197) = xpar(ji,jj,jk)    !! Pd PP
+                 !!    trc2d(ji,jj,198) = loc_T             !! local temperature
+                 !! endif
+                 !!
                   !! extract relevant BASIN fields at 150m
                   if (jk .eq. i0150) then
-                     !! trc2d(ji,jj,172) = trc2d(ji,jj,4)    !! Pn PP
-                     !! trc2d(ji,jj,173) = trc2d(ji,jj,151)  !! Pn linear loss
-                     !! trc2d(ji,jj,174) = trc2d(ji,jj,5)    !! Pn non-linear loss
-                     !! trc2d(ji,jj,175) = trc2d(ji,jj,11)   !! Pn grazing to Zmi
-                     !! trc2d(ji,jj,176) = trc2d(ji,jj,14)   !! Pn grazing to Zme
-                     !! trc2d(ji,jj,177) = trc2d(ji,jj,6)    !! Pd PP
-                     !! trc2d(ji,jj,178) = trc2d(ji,jj,152)  !! Pd linear loss
-                     !! trc2d(ji,jj,179) = trc2d(ji,jj,7)    !! Pd non-linear loss
-                     !! trc2d(ji,jj,180) = trc2d(ji,jj,15)   !! Pd grazing to Zme
-                     !! trc2d(ji,jj,181) = trc2d(ji,jj,12)   !! Zmi grazing on D
-                     !! trc2d(ji,jj,182) = trc2d(ji,jj,170)  !! Zmi grazing on Dc
-                     !! trc2d(ji,jj,183) = trc2d(ji,jj,155)  !! Zmi messy feeding loss to N
-                     !! trc2d(ji,jj,184) = trc2d(ji,jj,156)  !! Zmi messy feeding loss to D
-                     !! trc2d(ji,jj,185) = trc2d(ji,jj,157)  !! Zmi messy feeding loss to DIC
-                     !! trc2d(ji,jj,186) = trc2d(ji,jj,158)  !! Zmi messy feeding loss to Dc
-                     !! trc2d(ji,jj,187) = trc2d(ji,jj,159)  !! Zmi excretion
-                     !! trc2d(ji,jj,188) = trc2d(ji,jj,160)  !! Zmi respiration
-                     !! trc2d(ji,jj,189) = trc2d(ji,jj,161)  !! Zmi growth
-                     !! trc2d(ji,jj,190) = trc2d(ji,jj,153)  !! Zmi linear loss
-                     !! trc2d(ji,jj,191) = trc2d(ji,jj,13)   !! Zmi non-linear loss
-                     !! trc2d(ji,jj,192) = trc2d(ji,jj,16)   !! Zmi grazing to Zme
-                     !! trc2d(ji,jj,193) = trc2d(ji,jj,17)   !! Zme grazing on D
-                     !! trc2d(ji,jj,194) = trc2d(ji,jj,171)  !! Zme grazing on Dc
-                     !! trc2d(ji,jj,195) = trc2d(ji,jj,162)  !! Zme messy feeding loss to N
-                     !! trc2d(ji,jj,196) = trc2d(ji,jj,163)  !! Zme messy feeding loss to D
-                     !! trc2d(ji,jj,197) = trc2d(ji,jj,164)  !! Zme messy feeding loss to DIC
-                     !! trc2d(ji,jj,198) = trc2d(ji,jj,165)  !! Zme messy feeding loss to Dc
+                     trc2d(ji,jj,172) = trc2d(ji,jj,4)    !! Pn PP
+                     trc2d(ji,jj,173) = trc2d(ji,jj,151)  !! Pn linear loss
+                     trc2d(ji,jj,174) = trc2d(ji,jj,5)    !! Pn non-linear loss
+                     trc2d(ji,jj,175) = trc2d(ji,jj,11)   !! Pn grazing to Zmi
+                     trc2d(ji,jj,176) = trc2d(ji,jj,14)   !! Pn grazing to Zme
+                     trc2d(ji,jj,177) = trc2d(ji,jj,6)    !! Pd PP
+                     trc2d(ji,jj,178) = trc2d(ji,jj,152)  !! Pd linear loss
+                     trc2d(ji,jj,179) = trc2d(ji,jj,7)    !! Pd non-linear loss
+                     trc2d(ji,jj,180) = trc2d(ji,jj,15)   !! Pd grazing to Zme
+                     trc2d(ji,jj,181) = trc2d(ji,jj,12)   !! Zmi grazing on D
+                     trc2d(ji,jj,182) = trc2d(ji,jj,170)  !! Zmi grazing on Dc
+                     trc2d(ji,jj,183) = trc2d(ji,jj,155)  !! Zmi messy feeding loss to N
+                     trc2d(ji,jj,184) = trc2d(ji,jj,156)  !! Zmi messy feeding loss to D
+                     trc2d(ji,jj,185) = trc2d(ji,jj,157)  !! Zmi messy feeding loss to DIC
+                     trc2d(ji,jj,186) = trc2d(ji,jj,158)  !! Zmi messy feeding loss to Dc
+                     trc2d(ji,jj,187) = trc2d(ji,jj,159)  !! Zmi excretion
+                     trc2d(ji,jj,188) = trc2d(ji,jj,160)  !! Zmi respiration
+                     trc2d(ji,jj,189) = trc2d(ji,jj,161)  !! Zmi growth
+                     trc2d(ji,jj,190) = trc2d(ji,jj,153)  !! Zmi linear loss
+                     trc2d(ji,jj,191) = trc2d(ji,jj,13)   !! Zmi non-linear loss
+                     trc2d(ji,jj,192) = trc2d(ji,jj,16)   !! Zmi grazing to Zme
+                     trc2d(ji,jj,193) = trc2d(ji,jj,17)   !! Zme grazing on D
+                     trc2d(ji,jj,194) = trc2d(ji,jj,171)  !! Zme grazing on Dc
+                     trc2d(ji,jj,195) = trc2d(ji,jj,162)  !! Zme messy feeding loss to N
+                     trc2d(ji,jj,196) = trc2d(ji,jj,163)  !! Zme messy feeding loss to D
+                     trc2d(ji,jj,197) = trc2d(ji,jj,164)  !! Zme messy feeding loss to DIC
+                     trc2d(ji,jj,198) = trc2d(ji,jj,165)  !! Zme messy feeding loss to Dc
                      trc2d(ji,jj,199) = trc2d(ji,jj,166)  !! Zme excretion
                      trc2d(ji,jj,200) = trc2d(ji,jj,167)  !! Zme respiration
@@ -3231,6 +4225,6 @@
                      trc2d(ji,jj,211) = trc2d(ji,jj,67)   !! Fast detritus remineralisation, C
                      trc2d(ji,jj,212) = trc2d(ji,jj,150)  !! Community respiration
-                     trc2d(ji,jj,213) = fslownflux        !! Slow detritus N flux at 150 m
-                     trc2d(ji,jj,214) = fslowcflux        !! Slow detritus C flux at 150 m
+                     trc2d(ji,jj,213) = fslownflux(ji,jj) !! Slow detritus N flux at 150 m
+                     trc2d(ji,jj,214) = fslowcflux(ji,jj) !! Slow detritus C flux at 150 m
                      trc2d(ji,jj,215) = ffastn(ji,jj)     !! Fast detritus N flux at 150 m
                      trc2d(ji,jj,216) = ffastc(ji,jj)     !! Fast detritus C flux at 150 m
@@ -3260,5 +4254,5 @@
                   !!
                   trc3d(ji,jj,jk,1)  = ((fprn + fprd) * zphn)     !! primary production  
-                  trc3d(ji,jj,jk,2)  = fslownflux + ffastn(ji,jj) !! detrital flux
+                  trc3d(ji,jj,jk,2)  = fslownflux(ji,jj) + ffastn(ji,jj) !! detrital flux
                   trc3d(ji,jj,jk,3)  = fregen + (freminn * fthk)  !! remineralisation
 # if defined key_roam
@@ -3272,8 +4266,409 @@
             endif
          !! CLOSE horizontal loops
-         END DO
-         END DO
+         ENDDO
+         ENDDO
+         !!
+             IF( lk_iomput  .AND.  .NOT.  ln_diatrc  ) THEN
+                 !! first - 2D diag implemented 
+                 !!         on every K level
+                 !!-----------------------------------------
+                 !!  --
+                 !!second - 2d specific k level diags
+                 !!
+                 !!-----------------------------------------
+                 IF (jk.eq.1) THEN
+#   if defined key_debug_medusa
+                     IF (lwp) write (numout,*) 'trc_bio_medusa: diag jk = 1'
+                     CALL flush(numout)
+#   endif
+                     IF( med_diag%MED_QSR%dgsave ) THEN
+                         CALL iom_put( "MED_QSR"  , qsr ) !
+                     ENDIF
+                     IF( med_diag%MED_XPAR%dgsave ) THEN
+                         CALL iom_put( "MED_XPAR"  , xpar(:,:,jk) ) !
+                     ENDIF       
+                     IF( med_diag%OCAL_CCD%dgsave ) THEN
+                         CALL iom_put( "OCAL_CCD"  , ocal_ccd ) !
+                     ENDIF
+                     IF( med_diag%FE_0000%dgsave ) THEN
+                         CALL iom_put( "FE_0000"  , xFree ) !
+                     ENDIF                     
+                     IF( med_diag%MED_XZE%dgsave ) THEN
+                         CALL iom_put( "MED_XZE"  , xze ) !
+                     ENDIF 
+# if defined key_roam                     
+                     IF( med_diag%WIND%dgsave ) THEN
+                         CALL iom_put( "WIND"  , wndm )
+                     ENDIF
+                     IF( med_diag%ATM_PCO2%dgsave ) THEN
+                         CALL iom_put( "ATM_PCO2"  , f_pco2a2d )
+                         CALL wrk_dealloc( jpi, jpj,    f_pco2a2d  )
+                     ENDIF
+                     IF( med_diag%OCN_PH%dgsave ) THEN
+                         zw2d(:,:) = f3_pH(:,:,jk)
+                         CALL iom_put( "OCN_PH"  , zw2d )
+                     ENDIF
+                     IF( med_diag%OCN_PCO2%dgsave ) THEN
+                         CALL iom_put( "OCN_PCO2"  , f_pco2w2d )
+                          CALL wrk_dealloc( jpi, jpj,   f_pco2w2d   )
+                     ENDIF
+                     IF( med_diag%OCNH2CO3%dgsave ) THEN
+                         zw2d(:,:) = f3_h2co3(:,:,jk)
+                         CALL iom_put( "OCNH2CO3"  , zw2d )
+                     ENDIF
+                     IF( med_diag%OCN_HCO3%dgsave ) THEN
+                         zw2d(:,:) = f3_hco3(:,:,jk)
+                         CALL iom_put( "OCN_HCO3"  , zw2d )
+                     ENDIF
+                     IF( med_diag%OCN_CO3%dgsave ) THEN
+                         zw2d(:,:) = f3_co3(:,:,jk)
+                         CALL iom_put( "OCN_CO3"  , zw2d )
+                     ENDIF
+                     IF( med_diag%CO2FLUX%dgsave ) THEN
+                         CALL iom_put( "CO2FLUX"  , f_co2flux2d )
+                          CALL wrk_dealloc( jpi, jpj,   f_co2flux2d   )
+                     ENDIF
+                     IF( med_diag%OM_CAL%dgsave ) THEN
+                         CALL iom_put( "OM_CAL"  , f_omcal )
+                     ENDIF
+                     IF( med_diag%OM_ARG%dgsave ) THEN
+                         CALL iom_put( "OM_ARG"  , f_omarg )
+                     ENDIF
+                     IF( med_diag%TCO2%dgsave ) THEN
+                         CALL iom_put( "TCO2"  , f_TDIC2d )
+                          CALL wrk_dealloc( jpi, jpj,   f_TDIC2d   )
+                     ENDIF
+                     IF( med_diag%TALK%dgsave ) THEN
+                         CALL iom_put( "TALK"  , f_TALK2d )
+                          CALL wrk_dealloc( jpi, jpj,    f_TALK2d  )
+                     ENDIF
+                     IF( med_diag%KW660%dgsave ) THEN
+                         CALL iom_put( "KW660"  , f_kw6602d )
+                          CALL wrk_dealloc( jpi, jpj,   f_kw6602d   )
+                     ENDIF
+                     IF( med_diag%ATM_PP0%dgsave ) THEN
+                         CALL iom_put( "ATM_PP0"  , f_pp02d )
+                          CALL wrk_dealloc( jpi, jpj,    f_pp02d  )
+                     ENDIF
+                     IF( med_diag%O2FLUX%dgsave ) THEN
+                         CALL iom_put( "O2FLUX"  , f_o2flux2d )
+                          CALL wrk_dealloc( jpi, jpj,   f_o2flux2d   )
+                     ENDIF
+                     IF( med_diag%O2SAT%dgsave ) THEN
+                         CALL iom_put( "O2SAT"  , f_o2sat2d )
+                          CALL wrk_dealloc( jpi, jpj,  f_o2sat2d    )
+                     ENDIF
+                     IF( med_diag%CAL_CCD%dgsave ) THEN
+                         CALL iom_put( "CAL_CCD"  , f2_ccd_cal )
+                     ENDIF
+                     IF( med_diag%ARG_CCD%dgsave ) THEN
+                         CALL iom_put( "ARG_CCD"  , f2_ccd_arg )
+                     ENDIF
+                     IF (jdms .eq. 1) THEN
+                       IF( med_diag%DMS_SURF%dgsave ) THEN
+                         CALL iom_put( "DMS_SURF"  , dms_surf2d )
+                          CALL wrk_dealloc( jpi, jpj,   dms_surf2d   )
+                       ENDIF
+                       IF( med_diag%DMS_ANDR%dgsave ) THEN
+                         CALL iom_put( "DMS_ANDR"  , dms_andr2d )
+                          CALL wrk_dealloc( jpi, jpj,   dms_andr2d   )
+                       ENDIF
+                       IF( med_diag%DMS_SIMO%dgsave ) THEN
+                         CALL iom_put( "DMS_SIMO"  , dms_simo2d )
+                          CALL wrk_dealloc( jpi, jpj,    dms_simo2d  )
+                       ENDIF
+                       IF( med_diag%DMS_ARAN%dgsave ) THEN
+                         CALL iom_put( "DMS_ARAN"  , dms_aran2d )
+                          CALL wrk_dealloc( jpi, jpj,   dms_aran2d   )
+                       ENDIF
+                       IF( med_diag%DMS_HALL%dgsave ) THEN
+                         CALL iom_put( "DMS_HALL"  , dms_hall2d )
+                          CALL wrk_dealloc( jpi, jpj,   dms_hall2d   )
+                       ENDIF
+                     ENDIF
+# endif                     
+                 ELSE IF (jk.eq.i0100) THEN 
+#   if defined key_debug_medusa
+                     IF (lwp) write (numout,*) 'trc_bio_medusa: diag jk = 100'
+                     CALL flush(numout)
+#   endif
+                     IF( med_diag%SDT__100%dgsave ) THEN
+                         CALL iom_put( "SDT__100"  , fslownflux )
+                     ENDIF
+                     IF( med_diag%REG__100%dgsave ) THEN
+                         CALL iom_put( "REG__100"  , fregen2d )
+                     ENDIF
+                     IF( med_diag%FDT__100%dgsave ) THEN
+                         CALL iom_put( "FDT__100"  , ffastn )
+                     ENDIF           
+                     IF( med_diag%RG__100F%dgsave ) THEN
+                         CALL iom_put( "RG__100F"  , fregenfast )
+                     ENDIF
+                     IF( med_diag%FDS__100%dgsave ) THEN
+                         CALL iom_put( "FDS__100"  , ffastsi )
+                     ENDIF         
+                     IF( med_diag%RGS_100F%dgsave ) THEN
+                         CALL iom_put( "RGS_100F"  , fregenfastsi )
+                     ENDIF
+                     IF( med_diag%FE_0100%dgsave ) THEN
+                         CALL iom_put( "FE_0100"  , xFree )
+                     ENDIF
+# if defined key_roam                     
+                     IF( med_diag%RR_0100%dgsave ) THEN
+                         CALL iom_put( "RR_0100"  , ffastca2d )
+                     ENDIF                     
+                     IF( med_diag%SDC__100%dgsave ) THEN
+                         CALL iom_put( "SDC__100"  , fslowcflux )
+                     ENDIF                  
+                 ELSE IF (jk.eq.i0150) THEN
+#   if defined key_debug_medusa
+                     IF (lwp) write (numout,*) 'trc_bio_medusa: diag jk = 150'
+                     CALL flush(numout)
+#   endif
+                     IF( med_diag%BASIN_01%dgsave ) THEN
+                         CALL iom_put( "BASIN_01"  , fprn2d )
+                     ENDIF
+                     IF( med_diag%BASIN_02%dgsave ) THEN
+                         CALL iom_put( "BASIN_02"  , fdpn22d )
+                     ENDIF
+                     IF( med_diag%BASIN_03%dgsave ) THEN
+                         CALL iom_put( "BASIN_03"  , fdpn2d )
+                     ENDIF
+                     IF( med_diag%BASIN_04%dgsave ) THEN
+                         CALL iom_put( "BASIN_04"  , fgmipn2d )
+                     ENDIF
+                     IF( med_diag%BASIN_05%dgsave ) THEN
+                         CALL iom_put( "BASIN_05"  , fgmepn2d )
+                     ENDIF
+                     IF( med_diag%BASIN_06%dgsave ) THEN
+                         CALL iom_put( "BASIN_06"  , fprd2d )
+                     ENDIF
+                     IF( med_diag%BASIN_07%dgsave ) THEN
+                         CALL iom_put( "BASIN_07"  , fdpd22d )
+                     ENDIF
+                     IF( med_diag%BASIN_08%dgsave ) THEN
+                         CALL iom_put( "BASIN_08"  , fdpd2d )
+                     ENDIF
+                     IF( med_diag%BASIN_09%dgsave ) THEN
+                         CALL iom_put( "BASIN_09"  , fgmepd2d )
+                     ENDIF
+                     IF( med_diag%BASIN_10%dgsave ) THEN
+                         CALL iom_put( "BASIN_10"  , fgmid2d )
+                     ENDIF
+                     IF( med_diag%BASIN_11%dgsave ) THEN
+                         CALL iom_put( "BASIN_11"  , gmidc2d )
+                     ENDIF
+                     IF( med_diag%BASIN_12%dgsave ) THEN
+                         CALL iom_put( "BASIN_12"  , zimesn2d )
+                     ENDIF
+                     IF( med_diag%BASIN_13%dgsave ) THEN
+                         CALL iom_put( "BASIN_13"  , zimesd2d )
+                     ENDIF
+                     IF( med_diag%BASIN_14%dgsave ) THEN
+                         CALL iom_put( "BASIN_14"  , zimesc2d )
+                     ENDIF
+                     IF( med_diag%BASIN_15%dgsave ) THEN
+                         CALL iom_put( "BASIN_15"  , zimesdc2d )
+                     ENDIF
+                     IF( med_diag%BASIN_16%dgsave ) THEN
+                         CALL iom_put( "BASIN_16"  , ziexcr2d )
+                     ENDIF
+                     IF( med_diag%BASIN_17%dgsave ) THEN
+                         CALL iom_put( "BASIN_17"  , ziresp2d )
+                     ENDIF
+                     IF( med_diag%BASIN_18%dgsave ) THEN
+                         CALL iom_put( "BASIN_18"  , zigrow2d )
+                     ENDIF
+                     IF( med_diag%BASIN_19%dgsave ) THEN
+                         CALL iom_put( "BASIN_19"  , fdzmi22d )
+                     ENDIF
+                     IF( med_diag%BASIN_20%dgsave ) THEN
+                         CALL iom_put( "BASIN_20"  , fdzmi2d )
+                     ENDIF
+                     IF( med_diag%BASIN_21%dgsave ) THEN
+                         CALL iom_put( "BASIN_21"  , fgmezmi2d )
+                     ENDIF
+                     IF( med_diag%BASIN_22%dgsave ) THEN
+                         CALL iom_put( "BASIN_22"  , fgmed2d )
+                     ENDIF
+                     IF( med_diag%BASIN_23%dgsave ) THEN
+                         CALL iom_put( "BASIN_23"  , gmedc2d )
+                     ENDIF
+                     IF( med_diag%BASIN_24%dgsave ) THEN
+                         CALL iom_put( "BASIN_24"  , zemesn2d )
+                     ENDIF  
+                     IF( med_diag%BASIN_25%dgsave ) THEN
+                         CALL iom_put( "BASIN_25"  , zemesd2d )
+                     ENDIF
+                     IF( med_diag%BASIN_26%dgsave ) THEN
+                         CALL iom_put( "BASIN_26"  , zemesc2d )
+                     ENDIF
+                     IF( med_diag%BASIN_27%dgsave ) THEN
+                         CALL iom_put( "BASIN_27"  , zemesdc2d )
+                     ENDIF
+                     IF( med_diag%BASIN_28%dgsave ) THEN
+                         CALL iom_put( "BASIN_28"  , zeexcr2d )
+                     ENDIF
+                     IF( med_diag%BASIN_29%dgsave ) THEN
+                         CALL iom_put( "BASIN_29"  , zeresp2d )
+                     ENDIF
+                     IF( med_diag%BASIN_30%dgsave ) THEN
+                         CALL iom_put( "BASIN_30"  , zegrow2d )
+                     ENDIF
+                     IF( med_diag%BASIN_31%dgsave ) THEN
+                         CALL iom_put( "BASIN_30"  , fdzme22d )
+                     ENDIF
+                     IF( med_diag%BASIN_32%dgsave ) THEN
+                         CALL iom_put( "BASIN_32"  , fdzme2d )
+                     ENDIF
+                     IF( med_diag%BASIN_33%dgsave ) THEN
+                         CALL iom_put( "BASIN_33"  , fslown2d )
+                     ENDIF
+                     IF( med_diag%BASIN_34%dgsave ) THEN
+                         CALL iom_put( "BASIN_34"  , fdd2d )
+                     ENDIF
+                     IF( med_diag%BASIN_35%dgsave ) THEN
+                         CALL iom_put( "BASIN_35"  , fslowc2d )
+                     ENDIF
+                     IF( med_diag%BASIN_36%dgsave ) THEN
+                         CALL iom_put( "BASIN_36"  , mdetc2d )
+                     ENDIF
+                     IF( med_diag%BASIN_37%dgsave ) THEN
+                         CALL iom_put( "BASIN_37"  , ftempn2d )
+                     ENDIF
+                     IF( med_diag%BASIN_38%dgsave ) THEN
+                         CALL iom_put( "BASIN_38"  , freminn2d )
+                     ENDIF
+                     IF( med_diag%BASIN_39%dgsave ) THEN
+                         CALL iom_put( "BASIN_39"  , ftempc2d )
+                     ENDIF
+                     IF( med_diag%BASIN_40%dgsave ) THEN
+                         CALL iom_put( "BASIN_40"  , freminc2d )
+                     ENDIF
+                     IF( med_diag%BASIN_41%dgsave ) THEN
+                         CALL iom_put( "BASIN_41"  , fcomm_resp )
+                     ENDIF                  
+                     IF( med_diag%BASIN_42%dgsave ) THEN
+                         CALL iom_put( "BASIN_42"  , fslownflux )
+                     ENDIF
+                     IF( med_diag%BASIN_43%dgsave ) THEN
+                         CALL iom_put( "BASIN_43"  , fslowcflux )
+                     ENDIF
+                     IF( med_diag%BASIN_44%dgsave ) THEN
+                         CALL iom_put( "BASIN_44"  , ffastn )
+                     ENDIF
+                     IF( med_diag%BASIN_45%dgsave ) THEN
+                         CALL iom_put( "BASIN_45"  , ffastc )
+                     ENDIF
+# endif                     
+                 ELSE IF (jk.eq.i0200) THEN
+#   if defined key_debug_medusa
+                     IF (lwp) write (numout,*) 'trc_bio_medusa: diag jk = 200'
+                     CALL flush(numout)
+#   endif
+                     IF( med_diag%SDT__200%dgsave ) THEN
+                         CALL iom_put( "SDT__200"  , fslownflux )
+                     ENDIF
+                     IF( med_diag%REG__200%dgsave ) THEN
+                         CALL iom_put( "REG__200"  , fregen2d )
+                     ENDIF
+                     IF( med_diag%FDT__200%dgsave ) THEN
+                         CALL iom_put( "FDT__200"  , ffastn )
+                     ENDIF
+                     IF( med_diag%RG__200F%dgsave ) THEN
+                         CALL iom_put( "RG__200F"  , fregenfast )
+                     ENDIF
+                     IF( med_diag%FDS__200%dgsave ) THEN
+                         CALL iom_put( "FDS__200"  , ffastsi )
+                     ENDIF
+                     IF( med_diag%RGS_200F%dgsave ) THEN
+                         CALL iom_put( "RGS_200F"  , fregenfastsi )
+                     ENDIF
+                     IF( med_diag%FE_0200%dgsave ) THEN
+                         CALL iom_put( "FE_0200"  , xFree )
+                     ENDIF
+# if defined key_roam                     
+                     IF( med_diag%SDC__200%dgsave ) THEN
+                         CALL iom_put( "SDC__200"  , fslowcflux )
+                     ENDIF
+# endif                     
+                 ELSE IF (jk.eq.i0500) THEN
+#   if defined key_debug_medusa
+                     IF (lwp) write (numout,*) 'trc_bio_medusa: diag jk = 500'
+                     CALL flush(numout)
+#   endif
+                     IF( med_diag%SDT__500%dgsave ) THEN
+                         CALL iom_put( "SDT__500"  , fregen2d )
+                     ENDIF
+                     IF( med_diag%REG__500%dgsave ) THEN
+                         CALL iom_put( "REG__500"  , fregen2d )
+                     ENDIF      
+                     IF( med_diag%FDT__500%dgsave ) THEN
+                         CALL iom_put( "FDT__500"  , ffastn )
+                     ENDIF
+                     IF( med_diag%RG__500F%dgsave ) THEN
+                         CALL iom_put( "RG__500F"  , fregenfast )
+                     ENDIF
+                     IF( med_diag%FDS__500%dgsave ) THEN
+                         CALL iom_put( "FDS__500"  , ffastsi )
+                     ENDIF
+                     IF( med_diag%RGS_500F%dgsave ) THEN
+                         CALL iom_put( "RGS_500F"  , fregenfastsi )
+                     ENDIF
+                     IF( med_diag%FE_0500%dgsave ) THEN
+                         CALL iom_put( "FE_0500"  , xFree )
+                     ENDIF
+# if defined key_roam                     
+                     IF( med_diag%RR_0500%dgsave ) THEN
+                         CALL iom_put( "RR_0500"  , ffastca2d )
+                     ENDIF
+                     IF( med_diag%SDC__500%dgsave ) THEN
+                         CALL iom_put( "SDC__500"  , fslowcflux )
+                     ENDIF  
+# endif                      
+                 ELSE IF (jk.eq.i1000) THEN
+#   if defined key_debug_medusa
+                     IF (lwp) write (numout,*) 'trc_bio_medusa: diag jk = 1000'
+                     CALL flush(numout)
+#   endif
+                     IF( med_diag%SDT_1000%dgsave ) THEN
+                         CALL iom_put( "SDT_1000"  , fslownflux )
+                     ENDIF
+                     IF( med_diag%REG_1000%dgsave ) THEN
+                         CALL iom_put( "REG_1000"  , fregen2d )
+                     ENDIF  
+                     IF( med_diag%FDT_1000%dgsave ) THEN
+                         CALL iom_put( "FDT_1000"  , ffastn )
+                     ENDIF
+                     IF( med_diag%RG_1000F%dgsave ) THEN
+                         CALL iom_put( "RG_1000F"  , fregenfast )
+                     ENDIF
+                     IF( med_diag%FDS_1000%dgsave ) THEN
+                         CALL iom_put( "FDS_1000"  , ffastsi )
+                     ENDIF
+                     IF( med_diag%RGS1000F%dgsave ) THEN
+                         CALL iom_put( "RGS1000F"  , fregenfastsi )
+                     ENDIF
+                     IF( med_diag%FE_1000%dgsave ) THEN
+                         CALL iom_put( "FE_1000"  , xFree )
+                     ENDIF
+# if defined key_roam                     
+                     IF( med_diag%RR_1000%dgsave ) THEN
+                         CALL iom_put( "RR_1000"  , ffastca2d )
+                          CALL wrk_dealloc( jpi, jpj,  ffastca2d    )
+                     ENDIF
+                     IF( med_diag%SDC_1000%dgsave ) THEN
+                         CALL iom_put( "SDC_1000"  , fslowcflux )
+                     ENDIF 
+# endif                      
+                 ENDIF
+                 !! to do on every k loop :
+                 IF( med_diag%DETFLUX3%dgsave ) THEN
+                      detflux3d(:,:,jk) = fslownflux(:,:) + ffastn(:,:) !! detrital flux
+                      !CALL iom_put( "DETFLUX3"  , ftot_n )
+                 ENDIF
+             ENDIF
       !! CLOSE vertical loop
-      END DO
+      ENDDO
 
       !!----------------------------------------------------------------------
